#include "StdAfx.h"
#include "N163.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//		unsigned	int		_id			N163ԍ
//		const		wchar_t	_strName[]	IuWFNg
//	Ԓl
//					
//==============================================================
N163::N163(MMLfile* MML, unsigned int _id, const wchar_t _strName[]):
	MusicItem(_strName),
	m_id(_id)
{
	//----------------------
	//Localϐ


//	萔`
enum	Command_ID_mml {
	N163_Num,
	N163_Commma
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		{	"%",	N163_Num	},
		{	"$",	N163_Num	},
		{	"0",	N163_Num	},
		{	"1",	N163_Num	},
		{	"2",	N163_Num	},
		{	"3",	N163_Num	},
		{	"4",	N163_Num	},
		{	"5",	N163_Num	},
		{	"6",	N163_Num	},
		{	"7",	N163_Num	},
		{	"8",	N163_Num	},
		{	"9",	N163_Num	},
		{	",",	N163_Commma	}
};

				int		i;
	unsigned	char	cData;
	unsigned	int		ptN163		= 0;
				string	WAVE;

	//------------------------------
	//NX̏ݒ
	WAVE.clear();

	//------------------------------
	//RpC

	// { ̌
	while(MML->cRead() != '{'){
		if(MML->eof()){
			MML->Err(L"ubN̊Jn{܂B");
		}
	}

	code.resize(0);

	// } ܂ŁALqubNRpCB
	while((cData = MML->GetChar()) != '}'){
		
		// } OɁA[EOF]G[
		if( MML->eof() ){
			MML->Err(L"ubN̏I[`}'܂B");
		}

		//P߂
		MML->Back();


		//eR}h̏
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){

			case(N163_Num):
				MML->Back();
				i = MML->GetInt();
				if( (i<0) || (i>15)){
					MML->Err(L"n163̔g``́A0`15͈̔͂Ŏw肵ĉB");
				}
				WAVE.append((char)1, (char)i & 0x0F);
				ptN163++;
				break;

			case(N163_Commma):
				break;

			//unknown command
			default:
				MML->Err(L"unknown command");
				break;
		}
	}
	if(ptN163 > 128){
		MML->Err(L"Tv128zĂ܂B");
	}
	if((ptN163 & 0x03) != 0){
		MML->Err(L"Tv́AS̔{ƂĉB");
	}
	ptN163 >>= 1;
	code.append((char)1, ptN163);
	i = 0;
	while(ptN163>0){
		code.append((char)1, WAVE[i*2+0] | (WAVE[i*2+1]<<4) );
		i++;
		ptN163--;
	}


	iSize = code.size();
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
N163::~N163(void)
{
}
//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		MusicFile*	MUS		R[ho͂ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	N163::getAsm(MusicFile* MUS)
{
	*MUS << MUS->Header.Label.c_str() << "N163" << m_id << ":" << endl;
	MusicItem::getAsm(MUS);
}
